package
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;

	import robotlegs.bender.bundles.mvcs.MVCSBundle;
	import robotlegs.bender.extensions.contextView.ContextView;
	import robotlegs.bender.framework.api.IContext;
	import robotlegs.bender.framework.impl.Context;

	import yourdomain.configs.MediatorsConfig;
	import yourdomain.configs.ModelsConfig;
	import yourdomain.controllers.events.HelloEvent;
	import yourdomain.views.components.HelloSprite;

	public class HelloFlashPorted extends Sprite
	{
		private var _robotlegsContext:IContext;

		public function HelloFlashPorted()
		{
			stage.addEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, handleMouseWheel);

			initializeRobotlegsContext();

			addSprite();
		}

		private function initializeRobotlegsContext():void
		{
			_robotlegsContext = new Context();
			_robotlegsContext.install(MVCSBundle);
			_robotlegsContext.configure(ModelsConfig, MediatorsConfig, new ContextView(this));
		}

		public function addSprite():void
		{
			var helloSprite:HelloSprite = new HelloSprite();
			addChild(helloSprite);
		}

		// The user has released the mouse over the stage
		private function handleMouseUp(event:MouseEvent):void
		{
			dispatchEvent(new HelloEvent(HelloEvent.SPRITE_DROP));
		}

		// The user has released the mouse over the stage
		private function handleMouseWheel(event:MouseEvent):void
		{
			dispatchEvent(new HelloEvent(HelloEvent.SPRITE_SCALE, event.delta));
		}
	}
}
