﻿package yourdomain.models
{

	public class SpriteDataProxy
	{
		private var palette:Array;
		private var red:uint = 0xFF0000;
		private var green:uint = 0x00FF00;
		private var blue:uint = 0x0000FF;
		private var yellow:uint = 0xFFFF00;
		private var cyan:uint = 0x00FFFF;
		
		private var _spriteCount:Number;
		private var _newSpriteState:Array;
		
		public function SpriteDataProxy( )
		{
			palette = [blue, red, yellow, green, cyan];
		}
		
		public function get newSpriteState():Array
		{
			return _newSpriteState;
		}

		public function set newSpriteState(value:Array):void
		{
			_newSpriteState = value;
		}

		public function nextSpriteColor( startColor:uint ):uint
		{
			// identify color index
			var index:int;
			var found:Boolean = false;
			for (var j:int = 0; j < palette.length; j++)
			{
				index = j;
				if (startColor == palette[index])
					break;
			}

			// select the next color in the palette
			index = (index == palette.length - 1) ? 0 : index + 1;
			//return startColor;
			return palette[index];
		}

		/**
		 * Get the next Sprite ID
		 */
		public function get nextSpriteID():String
		{
			return "sprite_" + spriteCount++;
		}

		/**
		 * Get the next Sprite ID
		 */
		public function get spriteCount():Number
		{
			return data as Number;
		}

		public function set spriteCount(count:Number):void
		{
			data = count;
		}

		// the data object
		protected var data:Object;

		/**
		 * Set the data object
		 */
		public function setData( data:Object ):void
		{
			this.data = data;
		}

		/**
		 * Get the data object
		 */
		public function getData():Object
		{
			return data;
		}
	}
}
