package yourdomain.views.mediators
{
	import robotlegs.bender.bundles.mvcs.Mediator;
	
	import yourdomain.controllers.events.HelloEvent;
	import yourdomain.models.SpriteDataProxy;
	import yourdomain.views.components.HelloSprite;

	public class HelloSpriteMediator extends Mediator
	{
		[Inject]
		public var view:HelloSprite;

		[Inject]
		public var spriteDataProxy:SpriteDataProxy;

		override public function initialize():void
		{
			trace("HelloSpriteMediator.initialize()");
			addViewListener(HelloEvent.SPRITE_DIVIDE, onSpriteDivide, HelloEvent);

			addContextListener(HelloEvent.SPRITE_DROP, onSpriteDrop, HelloEvent);
			addContextListener(HelloEvent.SPRITE_SCALE, onSpriteScale, HelloEvent);

			initSprite();
		}

		private function initSprite():void
		{
			view.initSprite(spriteDataProxy.nextSpriteID, spriteDataProxy.newSpriteState);
		}

		private function onSpriteScale(event:HelloEvent):void
		{
			view.scaleSprite(event.payload as Number);
		}

		private function onSpriteDrop(event:HelloEvent):void
		{
			view.dropSprite();
		}

		private function onSpriteDivide(event:HelloEvent):void
		{
			spriteDataProxy.newSpriteState = event.payload as Array;
			view.color = spriteDataProxy.nextSpriteColor(view.color);
			spriteDataProxy.nextSpriteColor(view.color);
			dispatch(new HelloEvent(HelloEvent.STAGE_ADD_SPRITE));
		}
	}
}
